<?php
namespace WPT\Recipe\Recipe;

use Carbon_Fields\Field;
use Carbon_Fields\Container;

/**
 * TermMetaFields.
 */
class TermMetaFields
{
    protected $container;

    /**
     * Constructor.
     */
    public function __construct($container)
    {
        $this->container = $container;
    }

    public function register_fields()
    {
        $container = Container::make('term_meta', 'Category Fields')
            ->where('term_taxonomy', '=', 'wpt-food-recipe-cat')
            ->add_fields($this->get_fields());

        return $container;
    }

    public function get_fields()
    {
        $fields = [];

        $fields[] = Field::make('image', 'cat_image', 'Image')
            ->set_help_text('Set an image that defines the category. Images across all categories should have same aspect ratio');

        return $fields;
    }

}
